Index: /trunk/src/org/expeditee/gui/Popup.java
===================================================================
--- /trunk/src/org/expeditee/gui/Popup.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/Popup.java	(revision 1102)
@@ -19,126 +19,185 @@
 package org.expeditee.gui;
 
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Container;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.LayoutManager;
-
-import javax.swing.JComponent;
-import javax.swing.JPanel;
-
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.EnforcedClipStack.EnforcedClipKey;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Lifetime;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gui.PopupManager.PopupAnimator;
 import org.expeditee.items.ItemUtils;
 
 /**
+ * A Custom swing pop-up in Expeditee.
  * 
- * A Custom swing popup in Expeditee.
- * 
- * Expeditee popus can be re-used. Popups are always heavyweight (i.e. uses invalidation).
+ * Expeditee pop-ups can be re-used. Pop-ups are always heavyweight (i.e. uses invalidation).
  * 
  * @see {@link PopupManager}
  * 
  * @author Brook Novak
- * 
  */
-public abstract class Popup extends JPanel {
-	
+public abstract class Popup
+{
 	//Mike says: Can we get the border for the IW to which this popup corresponds?
-	// Brook says: Would be nice - but popups are actually independant from widgets
+	// Brook says: Would be nice - but popups are actually independent from widgets
 	//   =>Now: It is up to the user of the popup to set the border thickness
-	private static final BasicStroke DEFAULT_STROKE = new BasicStroke(2.0f);
-	
-	private BasicStroke _borderStroke = DEFAULT_STROKE;
-	private Color _borderColor = Color.BLACK;
-	
-	private boolean _isReadyToPaint = false;
+	private static final Stroke DEFAULT_STROKE = new Stroke(2.0f);
+	
+	private Stroke _borderStroke = DEFAULT_STROKE;
+	private Colour _borderColour = Colour.BLACK;
+	private Fill _backgroundFill = new Fill(Colour.WHITE);
+	
+	private PopupAnimator _animator = null;
+	
+	private Lifetime _autoHideTime = new Lifetime(Lifetime.INFINITE_LIFETIME);
+	private Runnable _autoHideRoutine = new Runnable()
+	{
+		@Override
+		public void run()
+		{
+			hide();
+			DisplayController.invalidateArea(getBounds());
+			DisplayController.requestRefresh(true);
+		}
+	};
+	
+	private boolean _hidden = true;
+
 	private boolean _consumeBackClick = false;
-	private boolean _autoHide = true;
-
-	/**
-	 * Creates a new popup.
-	 * Autohide is set to true.
-	 * 
-	 */
-	public Popup() {
-		super();
-		setVisible(false);
-	}
-	
-	/**
-	 * Creates a new popup.
-	 * 
-	 * @param layout the LayoutManager to use
-	 */
-	public Popup(LayoutManager layout) {
-		super(layout);
-		setVisible(false);
-	}
-
-	@Override
-	public void paint(Graphics g) {
-		super.paint(g);
-		
-		// Draw border - if not transparent
-		if (_borderStroke != null && _borderColor != null) {
-			g.setColor(_borderColor);
-			((Graphics2D)g).setStroke(_borderStroke);
-			g.drawRect(0, 0, getWidth(), getHeight());
-		}
-	}
-	
-	private void ignoreAWTPainting(Component c) {
-		
-		if (c instanceof JComponent) {
-			((JComponent)c).setDoubleBuffered(false);
-		}
-		
-		c.setIgnoreRepaint(true);
-		
-		if (c instanceof Container) {
-			for (Component child : ((Container) c).getComponents()) {
-
-				if (child instanceof Container) {
-					ignoreAWTPainting(child);
-				} else {
-					if (child instanceof JComponent) {
-						((JComponent)child).setDoubleBuffered(false);
-					}
-					
-					child.setIgnoreRepaint(true);
+
+	/**
+	 * Creates a new pop-up.
+	 * Auto-hide is set to true.
+	 */
+	public Popup(PopupAnimator animator)
+	{
+		setAnimator(animator);
+	}
+	
+	public Popup(PopupAnimator animator, long lifetime)
+	{
+		this(animator);
+		_autoHideTime.setLifetime(lifetime);
+	}
+	
+	public Lifetime getAutoHideTime()
+	{
+		return _autoHideTime;
+	}
+	
+	public void setAnimator(PopupAnimator animator)
+	{
+		_animator = animator;
+	}
+	
+	public PopupAnimator getAnimator()
+	{
+		return _animator;
+	}
+	
+	public boolean isShowing()
+	{
+		return !_hidden;
+	}
+	
+	public void show()
+	{
+		if (_hidden) onShow();
+		
+		if (_animator != null) {
+			_animator.show();
+			if (!_animator.isFinished()) {
+				_autoHideTime.cancelExpiry();
+			} else {
+				_autoHideTime.refresh();
+				_autoHideTime.onExpiry(_autoHideRoutine);
+			}
+		} else {
+			_autoHideTime.refresh();
+			_autoHideTime.onExpiry(_autoHideRoutine);
+		}
+		
+		_hidden = false;
+	}
+
+	public void hide()
+	{
+		if (!_hidden) onHide();
+		
+		if (_animator != null) _animator.hide();
+		_autoHideTime.cancelExpiry();
+		_hidden = true;
+	}
+	
+	public boolean update()
+	{
+		if (_animator != null) {
+			if (!_hidden && !_animator.isFinished()) {
+				if (!_animator.update()) {
+					_autoHideTime.refresh();
+					_autoHideTime.onExpiry(_autoHideRoutine);
 				}
 			}
-		}
-		
-	}
-	
-	/**
-	 * Ensures that AWT painting turned off
-	 */
-	void prepareToPaint() {
-		if (!_isReadyToPaint) {
-			_isReadyToPaint = true;
-			ignoreAWTPainting(this);
-		}
-	}
-	
-	/**
-	 * Invoked when the popup becomes hidden, or when the popup is animating to show but cancelled.
-	 */
-	public void onHide() {} 
-	
-	/**
-	 * Invoked when the popup shows. Note this might not eventuate for animated popups.
-	 */
-	public void onShow() {}
-	
-	/**
-	 * Invoked when popups is going to show.
-	 * This always is invoked first.
-	 */
-	public void onShowing() {}
-
-	public boolean shouldConsumeBackClick() {
+			
+			if (_hidden && !_animator.isFinished()) {
+				return _animator.update();
+			}
+		} else {
+			if (_autoHideTime.hasExpired()) hide();
+		}
+		
+		return false;
+		
+	}
+	
+	public final void paint()
+	{
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		
+		// Make sure the popup isn't hidden
+		AxisAlignedBoxBounds currentBounds = getBounds();
+		if (currentBounds == null) return;
+		
+		// Draw border and background
+		g.drawRectangle(currentBounds, 0.0, _backgroundFill, _borderColour, _borderStroke, null);
+		
+		EnforcedClipKey key = g.pushClip(new Clip(currentBounds));
+		
+		paintInternal();
+		
+		g.popClip(key);
+	}
+	
+	/** Draws the interior paint area of the popup. */
+	protected abstract void paintInternal();
+	
+	/** Gets the bounds of this popup when it's fully shown. */
+	public abstract AxisAlignedBoxBounds getFullBounds();
+	
+	/** Gets the bounds of this popup in its current animated state. */
+	public AxisAlignedBoxBounds getBounds()
+	{
+		if (_animator == null) {
+			if (_autoHideTime.hasExpired()) {
+				return null;
+			} else {
+				return getFullBounds();
+			}
+		}
+		
+		return _animator.getAnimatedBounds(getFullBounds());
+	}
+	
+	/** Invoked when the popup becomes hidden, or when the popup is animating to show but cancelled. */
+	public abstract void onHide();
+	
+	/** Invoked when the popup shows. Note this might not eventuate for animated popups. */
+	public abstract void onShow();
+
+	public boolean shouldConsumeBackClick()
+	{
 		return _consumeBackClick;
 	}
@@ -150,15 +209,7 @@
 	 * 		consume the back-click event.
 	 */
-	protected void setConsumeBackClick(boolean consumeBackClick) {
+	protected void setConsumeBackClick(boolean consumeBackClick)
+	{
 		_consumeBackClick = consumeBackClick;
-	}
-	
-	/**
-	 * @param autoHideOn
-	 * 		Set to True if this popup should auto hide. (The default).
-	 * 		Set to false if this popup should be manually hidden.
-	 */
-	protected void setAudoHide(boolean autoHideOn) {
-		_autoHide = autoHideOn;
 	}
 	
@@ -167,6 +218,7 @@
 	 * 		True if this popup auto hides.
 	 */
-	public boolean doesAutoHide() {
-		return _autoHide;
+	public boolean doesAutoHide()
+	{
+		return _autoHideTime.remainingLifetime() != Lifetime.INFINITE_LIFETIME;
 	}
 	
@@ -177,19 +229,22 @@
 	 * 		The new thickness to set. Null for no border.
 	 */
-	public void setBorderThickness(float thickness) {
+	public void setBorderThickness(float thickness)
+	{
 		assert(thickness >= 0);
 		
-		if (_borderStroke != null && _borderStroke.getLineWidth() == thickness)
-			return;
+		if (_borderStroke != null && _borderStroke.thickness == thickness) return;
 		
 		boolean posInvalidate = true;
 		
-		if (thickness < _borderStroke.getLineWidth()) {
+		if (thickness < _borderStroke.thickness) {
 			invalidateAppearance();
 			posInvalidate = false;
 		}
 		
-		if (thickness == 0) _borderStroke = null;
-		else _borderStroke = new BasicStroke(thickness);
+		if (thickness == 0) {
+			_borderStroke = null;
+		} else {
+			_borderStroke = new Stroke(thickness);
+		}
 		
 		if (posInvalidate) invalidateAppearance();
@@ -201,8 +256,9 @@
 	 * 		The border thickness of this popup. Zero or more.
 	 */
-	public float getBorderThickness() {
+	public float getBorderThickness()
+	{
 		if (_borderStroke == null) return 0.0f;
-		return _borderStroke.getLineWidth();
-
+
+		return _borderStroke.thickness;
 	}
 	
@@ -214,39 +270,38 @@
 	 * 		The new color. Null for transparent.
 	 */
-	public void setBorderColor(Color c) {
-		
-		if (c == null && _borderColor != null) 
+	public void setBorderColor(Colour c)
+	{
+		if (c == null && _borderColour != null)  invalidateAppearance();
+		
+		if (c != _borderColour) {
+			_borderColour = c;
 			invalidateAppearance();
-		
-		if (c != _borderColor) {
-			_borderColor = c;
-			invalidateAppearance();
-		}
-	}
-	
-	/**
-	 * 
+		}
+	}
+	
+	/**
 	 * @return
 	 * 		The border color for the popup. NUll if transparent
 	 */
-	public Color getBorderColor() {
-		return _borderColor;
-	}
-	
-	/**
-	 * Invalidates the whole popup so that it must be fully repainted.
-	 */
-	public void invalidateAppearance() {
-		
-		if (_borderColor != null && _borderStroke != null && _borderStroke.getLineWidth() > 0) { // border
-			FrameGraphics.invalidateArea(ItemUtils.expandRectangle(getBounds(), 
-					(int)Math.ceil(getBorderThickness()) + 1));
+	public Colour getBorderColor()
+	{
+		return _borderColour;
+	}
+	
+	/**
+	 * Invalidates the whole pop-up so that it must be fully repainted.
+	 */
+	public void invalidateAppearance()
+	{
+		AxisAlignedBoxBounds bounds = getBounds();
+		
+		if (bounds == null) return;
+		
+		if (_borderColour != null && _borderStroke != null && _borderStroke.thickness > 0) { // border
+			DisplayController.invalidateArea(ItemUtils.expandRectangle(bounds, (int)Math.ceil(getBorderThickness()) + 1));
 		} else { // no border
-			FrameGraphics.invalidateArea(getBounds());
-		}
-
-	}
-	
-
-	
+			DisplayController.invalidateArea(bounds);
+		}
+
+	}
 }
